package lxr.marketplace.sitemapbuilder;

import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.List;
import org.apache.log4j.Logger;

/**
 *
 * @author netelixir1
 */
public class BuildSiteMapHtml implements Runnable {

    private static Logger logger = Logger.getLogger(BuildSiteMapHtml.class);

    private final String appPath;
    private String dwnHTMLfileName;
    private List<SitemapUrl> hTMLSortURLS = null;
    private final int phaseCount;

    public String getDwnHTMLfileName() {
        return dwnHTMLfileName;
    }

    public void setDwnHTMLfileName(String dwnHTMLfileName) {
        this.dwnHTMLfileName = dwnHTMLfileName;
    }

    public BuildSiteMapHtml(String downloadFolder, List<SitemapUrl> sortingURLS, int phaseCount) {
        this.appPath = downloadFolder;
        hTMLSortURLS = sortingURLS;
        this.phaseCount = phaseCount;
    }

    @Override
    public void run() {
        dwnHTMLfileName = writeInToSiteMapHtml();
    }

    public String writeInToSiteMapHtml() {
        logger.info("*** Started creating SiteMapHTML for URL Size:: " + this.hTMLSortURLS.size()+", ****");
        String htmlFileName = null;
        if (phaseCount != 0) {
            htmlFileName = "sitemap-" + phaseCount + ".html";
        } else {
            htmlFileName = "sitemap.html";
        }
        PrintWriter pw;
//        List<SitemapUrl> htmlsortUrls = SiteMapBuilderToolController.newSortingurls(sMBThread);
        try {
            long urlStatusCount = hTMLSortURLS.stream().filter(siteURL -> ((siteURL.getSitemapUrl() != null) && (!siteURL.getSitemapUrl().equals("")) && (!siteURL.getSitemapUrl().equals("&nbsp;")))).filter(siteURL -> (((siteURL.getStatuscode() == 302) || (siteURL.getStatuscode() == 200)))).count();
            if (urlStatusCount != 0) {
                pw = new PrintWriter(new FileWriter(appPath + htmlFileName));
                pw.println("<html>");
                pw.println("<head>");
                pw.println("<title>Site Map  Page 1 - Generated by www.LXRMarketPlace.com</title>");
                pw.println("<meta http-equiv=\"Content-type\" content=\"text/html; charset=utf-8\" />");
                pw.println("<style type=\"text/css\">");
                pw.println("body {"
                        + "background-color: #DDD;"
                        + " font: normal 80% " + " \"Trebuchet MS\"," + " \"Helvetica\"," + " sans-serif; "
                        + "margin:0;"
                        + "text-align:center;}");
                pw.println("#cont{"
                        + "margin:auto;"
                        + "width:800px;"
                        + "text-align:left;"
                        + "}");
                pw.println("a:hover {"
                        + "color: #666;"
                        + "}");
                pw.println("h1 {"
                        + "background-color:#fff;"
                        + "padding:20px;"
                        + "color:#FF6600;"
                        + "text-align:left;"
                        + "font-size:32px;"
                        + "margin:0px;"
                        + "}");
                pw.println("tr {"
                        + "background: #fff"
                        + "}");
                pw.println("tr:nth-child(odd) {"
                        + "background: #f0f0f0"
                        + "}");
                pw.println(".lpage {"
                        + "font:normal 14px verdana;"
                        + "line-height:25px;"
                        + "overflow:hidden;"
                        + "max-width: 100px;"
                        + "}");
                pw.println("td, th {"
                        + "display: table-cell;"
                        + "vertical-align: inherit;"
                        + "overflow:hidden;"
                        + "max-width: 100px;"
                        + "}");
                pw.println(".lpage a,a:visited {"
                        + "color: #0180AF;"
                        + "text-decoration: underline;"
                        + "overflow:hidden;"
                        + "cursor:pointer"
                        + "}");
                pw.println("</style>");
                pw.println("</head>");
                pw.println("<body>");
                pw.println("<div id=\"cont\">");
                pw.println("<h1>HTML Site Map</h1>");
                pw.println("<br>");
                pw.println("<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\"  width=\"100%\">");
                hTMLSortURLS.stream().filter((arrlist) -> ((arrlist.getSitemapUrl() != null) && (!arrlist.getSitemapUrl().equals(" ")) && (!arrlist.getSitemapUrl().equals("&nbsp;")))).filter((arrlist) -> (((arrlist.getStatuscode() == 302) || (arrlist.getStatuscode() == 200)))).filter((arrlist) -> ((arrlist.getSitemapUrl() != null) && (!arrlist.getSitemapUrl().equals(" ")) && (!arrlist.getSitemapUrl().equals("&nbsp;")))).forEach((arrlist) -> {
                    pw.println("<tr><td class=\"lpage\"><a href= \"" + arrlist.getSitemapUrl() + "\"> " + arrlist.getSitemapUrl() + " </a></td></tr>");
                });
                pw.println("</table>");
                pw.println("</div>");
                pw.println("</body>");
                pw.println("</html>");
                pw.close();
                logger.info("*** Compeleted generating HTML File for Sorting URLS: " + hTMLSortURLS.size() + ", and  HTML File File Path is: " + htmlFileName +" *****");
            } else {
                htmlFileName = "emptyHTML";
            }
        } catch (IOException e) {
            logger.error("Exception in buildHtml method  of SiteMapBulider Contoller", e);
        }
        return htmlFileName;
    }
}
